%% construct eigenvalue problem for Floquet multipliers using sparse matrices
% for case with only one-sided delays. This is based on eigs and permits
% optional argument 'closest' for finding Floquet multipliers close to a
% particular value.
%
% (c) DDE-BIFTOOL v. 3.2a(308), 28/10/2018
%%
function [s,ef]=dde_psol_mult_app_sparse(Mfun,dim,varargin)
default={'geteigenfuncs',false,...
    'closest',[],'max_number_of_eigenvalues',20,'method',[]};
[options,pass_on]=dde_set_options(default,varargin,'pass_on','method');
n_ev=min(options.max_number_of_eigenvalues,dim);
closest=num2cell(options.closest);
if ~options.geteigenfuncs
    s=eigs(Mfun,dim,n_ev,closest{:},pass_on{:});
    ef=[];
else
    [ef,s]=eigs(Mfun,dim,n_ev,closest{:},pass_on{:});
    s=diag(s);
end
end
